/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.stimmzettel;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.stimmzettel.boundary.AbstractStimmzettelSearchParameters;
import de.ivu.elect.business.stimmzettel.boundary.StimmzettelChangeEvent;
import de.ivu.elect.business.stimmzettel.boundary.StimmzettelConversationStore;
import de.ivu.elect.business.stimmzettel.boundary.StimmzettelExtendedDAO;
import de.ivu.elect.business.stimmzettel.boundary.StimmzettelSearch;
import de.ivu.elect.business.stimmzettel.boundary.StimmzettelSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.stimmzettel.entity.Stimmzettel;
import de.ivu.elect.business.stimmzettel.entity.StimmzettelMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractStimmzettelSearchView.COMPONENT_NAME)
@View(viewId = AbstractStimmzettelSearchView.VIEW_ID, useCase = UseCasePermission.STIMMZETTEL_SEARCH)
public abstract class AbstractStimmzettelSearchView extends AbstractElectSearchView<Stimmzettel> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "stimmzettelSearchView";
  
  public static final String VIEW_ID = "/stimmzettel/stimmzettel-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractStimmzettelSearchView requestHandler;

  @Inject
  private transient StimmzettelExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(StimmzettelConversationStore.class)
  protected transient StimmzettelConversationStore conversationStore;

  @Inject
  protected transient StimmzettelSearch search;

  @Inject
  @ConversationGroup(AbstractStimmzettelSearchParameters.class)
  protected transient StimmzettelSearchParameters searchParameters;

  @Inject
  protected transient StimmzettelMeta entityMeta;

  public AbstractStimmzettelSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public Stimmzettel getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(Stimmzettel entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public StimmzettelSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<Stimmzettel> getEagerLoadingCollector() {
    return EagerLoadingCollector.<Stimmzettel> create();
  }

  @Override
  public List<Stimmzettel> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<Stimmzettel> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onStimmzettelChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) StimmzettelChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractStimmzettelSearchView {

    @View
    @Inject
    private transient Instance<AbstractStimmzettelSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractStimmzettelSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
